/*
* Politecnico di Milano
* Corso Informatica Medica 2012/2013 - Prof. Santambrogio
* Esercizi di: Alessandro A. Nacci
* Grazie a: Ing. Alessandra Bonetto - IEIM2012
* E-mail: alessandro.nacci@mail.polimi.it
* Web: www.alessandronacci.com
* ------------------------------------
*/


/****
*
*	IL GIOCO DELL'IMPICCATO
*	---------------------------------	
*
*/

#include <stdio.h>
#include <string.h>

#define TENTATIVI 10

int scegliParola();
void stampa(char* parola, int len, int tentativi);
int check(char* parola, int len);
int selezionaLettere(char * parola_da_indovinare, char* stato_parola, char lettera);

int main(){
	
	//Dizionario di parole
	char dizionario[5][20]={"computer", "proiettore", "aula", "ciao", "telecomando"};

	int i;
	int tentativi=0;
	int found=0;

	//Puntatore alla parola da indovinare, scelta casualmente
	char* parola_da_indovinare;	
	parola_da_indovinare = dizionario[scegliParola()];	

	//Campo di gioco, stato della parola
	char stato_parola[20];				
	
	//Lunghezza della parola da indovinare		
	int len = strlen(parola_da_indovinare);		
	
	char lettera;

	for(i=0;i<len;i++)
		stato_parola[i]='_';					//Inizializzo il campo da gioco con '_'



	while(!found && tentativi<TENTATIVI){		
	//Chiedo lettere, finchè non indovina la parola o esaurisce i tentativi
		
		stampa(stato_parola, len, tentativi);
		printf("Inserisci una lettera\n");
		scanf("%c", &lettera);
		getchar();

		int result = selezionaLettere(parola_da_indovinare, stato_parola, lettera);
		if(result==0)
			tentativi++;
		else if(check(stato_parola, len))
			found=1;
	}	

	stampa(stato_parola, len, tentativi);
	if(found==1)
		printf("Complimenti!\n");
	else 
		printf("Hai superato i tentativi a disposizione\n");	

	return 0;


}


int scegliParola(){
	int num;
	srand(time(0));
	//Estraggo un numero tra 0 e "numero di parole del dizionario"
	num=rand()%5;	
	return num;
}

void stampa(char* parola, int len, int tentativi){

	int i;
	printf("Hai a disposizione ancora %d tentativi\n", 
				TENTATIVI - tentativi);	
	for(i=0;i<len;i++)
		printf("%c ", parola[i]);
	printf("\n");
}

int selezionaLettere(char * parola_da_indovinare, 
					char* stato_parola, char lettera)
{
	
	int i;
	int count=0;

	//Segno nel campo da gioco, tutte le posizioni 
	//corrispondenti alla lettera scelta dall'utente
	for(i=0;i<strlen(parola_da_indovinare);i++)
		if(parola_da_indovinare[i]==lettera)
		{
				stato_parola[i]=lettera;
				count++;
		}

	if(count==0)
		return 0;
	else
		return 1;	

}

//Controllo se la parola è stata completata
int check(char* stato_parola, int len){
	int i;
	for(i=0;i<len;i++)
		if(stato_parola[i]=='_')
			return 0;

	return 1;
}


	